--- /usr/sbin/checkrestart	2011-10-25 00:20:00.000000000 +0200
+++ /tmp/checkrestart	2012-01-23 22:59:43.052505207 +0100
@@ -426,6 +426,18 @@
 
         try:
             self.program = os.readlink('/proc/%d/exe' % self.pid)
+            # if the executable command is an interpreter such as perl/python,
+            # we want to find the real program
+            m = re.match("^/usr/bin/(perl|python)$", self.program)
+            if m:
+                with open('/proc/%d/cmdline' % self.pid, 'r') as cmdline:
+                    # only match program in /usr (ex.: /usr/sbin/smokeping)
+                    # ignore child, etc.
+                    m = re.search(r'^(([/]\w*){1,5})\s.*$', cmdline.read())
+                    if m:
+                        # store the real full path of script as the program
+                        self.program = m.group(1)
+            
         except OSError, e:
             if e.errno != errno.ENOENT:
                 raise
